// Group: SJSU Students

#include <stdlib.h>
#include <string.h>
#include "expressions.h"

char *concat_str(const char *s1, const char *s2)
{
    if (s1 == NULL)
        return s2;
    if (s2 == NULL)
        return s1;
    char *s = malloc(strlen(s1) + strlen(s2) + 1);
    char *p = s;
    char *q = s1;
    while (*q != '\0')
        *(p++) = *(q++);
    q = s2;
    while (*q != '\0')
        *(p++) = *(q++);
    *p = '\0';
    return s;
}

char *eval(Expression e)
{
    switch (e.data.op)
    {
    case CONS:
        if (e.leftArg == NULL)
            return eval(*e.rightArg);
        else if (e.rightArg == NULL)
            return eval(*e.leftArg);
        else
            return concat_str(eval(*e.leftArg), eval(*e.rightArg));
        break;
    case FIRST:
        if (e.leftArg == NULL)
            return NULL;
        else
            return eval(*e.leftArg);
        break;
    case REST:
        if (e.leftArg == NULL)
            return NULL;
        else
            return eval(*e.leftArg) + 1;
    default:
        return e.data.chr;
        break;
    }
}
